VERSION 5.00
Begin VB.UserControl InternetReader 
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   Picture         =   "InternetReader.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "InternetReader.ctx":08CA
End
Attribute VB_Name = "InternetReader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event Connected()
Public Event IPAddressDetect(ByVal IPAddr$)
Public Event ReadProgress(ByVal CurrBytes&, ByVal TotalBytes&, ByVal TransferRate#, ByVal TimeLeft#, ByVal sData$)
Public Event ReadComplete(ByVal TotalBytes&, ByVal sData$)
Public Event ReadError()
Public Event ReadCancel()
Public Event TotalBytesDefined(ByVal TotalBytes&)

Private Declare Function GetTickCount& Lib "kernel32" ()

Dim PropName$, tr#, LastTm&, TmDiff&, LastRead&, NewDataRate!, TBRead As Boolean, IsConnected As Boolean, IPAddressRaised As Boolean

Private Function InStrCount(ByVal String1 As String, ByVal String2 As String, Optional ByVal CaseSensitive As Boolean = False) As Long
Dim i&, MyCnt&, StrLen&, Comp As VbCompareMethod
StrLen = Len(String2)
If CaseSensitive Then Comp = vbBinaryCompare Else Comp = vbTextCompare

i = InStr(1, String1, String2, Comp)
While i > 0
    MyCnt = MyCnt + 1
    i = InStr(i + StrLen, String1, String2, Comp)
Wend

InStrCount = MyCnt
End Function

Private Sub Resize()
On Error GoTo handle
Width = ScaleX(32, vbPixels, vbTwips)
Height = ScaleY(32, vbPixels, vbTwips)
Exit Sub
handle:
    MsgBox "Error from Resize()!" & vbCrLf & vbCrLf & "Code: " & Err.Number & vbCrLf & "Description: " & Err.Description, 16, "Error"
End Sub

Public Function RetrieveData(URL$) As Boolean
On Error Resume Next
UserControl.Refresh
PropName = "ID" & Format$(Now, "YYYYMMDDHHNNSS") & Format$((Timer * 100) Mod 100, "00")
If LastRead <> 0 Then LastRead = 0
If TBRead Then TBRead = False
If IsConnected Then IsConnected = False
If IPAddressRaised Then IPAddressRaised = False
UserControl.AsyncRead URL, vbAsyncTypeByteArray, PropName, vbAsyncReadResynchronize
RetrieveData = Err
End Function

Public Function StopRetrievingData() As Boolean
On Error Resume Next
UserControl.CancelAsyncRead PropName
RaiseEvent ReadCancel
StopRetrievingData = Err
End Function

Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
On Error Resume Next
If AsyncProp.BytesMax = 0 Then
    RaiseEvent ReadError
Else
    RaiseEvent ReadComplete(AsyncProp.BytesMax, StrConv(AsyncProp.Value, vbUnicode))
End If
End Sub

Private Sub UserControl_AsyncReadProgress(AsyncProp As AsyncProperty)
On Error Resume Next
Dim MyStat$
If Not IsConnected Then
    If IPAddressRaised Then
        If AsyncProp.Status = "" Then
            RaiseEvent Connected
            IsConnected = True
        End If
    End If
End If
If Not TBRead Then
    If AsyncProp.BytesRead > 0 Then
        RaiseEvent TotalBytesDefined(AsyncProp.BytesMax)
        TBRead = True
    End If
End If
If Not IPAddressRaised Then
    MyStat = AsyncProp.Status
    If InStrCount(MyStat, ".") = 3 And IsNumeric(Replace(MyStat, ".", "")) Then
        RaiseEvent IPAddressDetect(MyStat)
        IPAddressRaised = True
    End If
End If
TmDiff = GetTickCount - LastTm
If AsyncProp.BytesMax <> 0 Then
    If TmDiff > 0 Then
        tr = (AsyncProp.BytesRead - LastRead) * 1000 / TmDiff
        RaiseEvent ReadProgress(AsyncProp.BytesRead, AsyncProp.BytesMax, tr, ((AsyncProp.BytesMax - AsyncProp.BytesRead) / tr) + 0.999, StrConv(AsyncProp.Value, vbUnicode))
        LastRead = AsyncProp.BytesRead
    End If
End If
LastTm = GetTickCount
End Sub

Private Sub UserControl_Initialize()
Resize
End Sub

Private Sub UserControl_Resize()
Resize
End Sub
